/* merge results of mate_pg.exe NbPlies [RNBQKBNR] */
//pour chaque fichier
//  aller aprs "Ending moves"
//  aller aprs LF
//  tant que le debut de ligne n'est pas LF
//    convertis le coup
//    insertmove avec occurence et n de fichier si nouveau coup
//    aller aprs LF
//  fin tant que
//  aller aprs "Possible"
//  aller aprs LF
//  tant que le dbut de ligne n'est pas LF
//    aller aprs " "
//    pour chaque case de la baseline noire, compter le nb d'occurence de chaque pice
//    aller aprs LF
//  fin tant que
//  en dduire baseline et sauver avec n de position
//prochain fichier
//trier les coups
//...etc...
/* 
Ending moves;occurences
3.Qf5xPc5#;2
3... Qd6-d4#;1
ETC...
4.Qf5xPc5#;3767

ply;    NbGames   ;NbEndMoves;NbUniqueEM; NbMates ; NbStalemates
  1;            19;         0;        0;        0;        0
ETC...
  7;    2294423860;       117;        9;    12088; untested

Possible problems are:
4.Qa4-a6# rq1rbbnn/pkpppppp/8/8/Q7/8/1PPPPPPP/R1KRBBNN
ETC...
*3... Q-b4# r1krbbnn/pp1ppppp/8/2p5/5q2/2KP4/PPP1PPPP/RQ1RBBNN
3... Qf4xPd4# r1krbbnn/pp1ppppp/8/2p5/3P1q2/3K4/PPP1PPPP/RQ1RBBNN
   
*/

#include <stdio.h>  /* file functions, etc... */
#include <stdlib.h> /* exit(), malloc() */

#define FALSE 0
#define TRUE 1

#define StartFile 1
char *FileName="0001.txt";
#define EndFile 144

#define MaxNbEndMoves 99999
int NbPlies=10;

unsigned int EndMove[MaxNbEndMoves],EndMoveOccurence[MaxNbEndMoves];
unsigned int EndMoveFileNb[MaxNbEndMoves];
unsigned int IM_Ply,IM_Move,IM_Found,IM_y,IM_x,IM_t,IM_t2;
int NbEndMoves=0;

/* c is for color (0=White, 1=Black), must be lowest bit. */
/* 2nd bit is set for pieces. And Q=B+R. */
#define ES 0  /* 000000 empty square */
#define FS 1  /* 000001 forbidden squares around the board */
#define WK 2  /* 00001c K */
#define BK 3
#define WP 6  /* 00011c P */
#define BP 7
#define WN 10 /* 00101c N */
#define BN 11
#define WB 18 /* 01001c B */
#define BB 19
#define WR 34 /* 10001c R */
#define BR 35
#define WQ 50 /* 11001c Q */
#define BQ 51



/**** SearchNext routine, brute force version ******************************/
/* To speed up this routine, copy beforehand the string to search at the   */
/* end of the text (you must allocate a bit more memory) and remove the    */
/* TextPos+StringLength<=TextLength condition in main loop. The routine    */
/* will always find a string, once this is done, compare Pos+Length and    */
/* return -1 if it is the one we added!                                    */
int SearchNext(char *String,int StringLength,
               char *Text,int TextLength,int TextPos) {
  int NbMatch=0;
  while((NbMatch<StringLength) && (TextPos+StringLength<=TextLength)) {
    if(Text[TextPos+NbMatch]==String[NbMatch]) {
      NbMatch++;
    } else {
      NbMatch=0;
      TextPos++;
    }
  }
  if(NbMatch==StringLength) {
    return(TextPos);
  } else {
    return(-1);
  }
}

/* used to print the ending move in standard format */
void PrintMove(Move,Mask) unsigned int Move,Mask; {
  int t;
  t=(Move>>26) & 63;
/*!!!    for(i=0;i<y;i++) { printf("  "); }*/
  printf("%d.",t+1);
  t=(Move>>20) & 62; /* piece without color */
  switch(t) {
    case WK: printf("K"); break;
    case WP: printf("P"); break;
    case WN: printf("N"); break;
    case WB: printf("B"); break;
    case WR: printf("R"); break;
    case WQ: printf("Q"); break;
    default: printf("***error1***");
  }
  if((Mask & 8)!=0) {
    t=((Move>>14)&127) - 21; /* square */
    printf("%c%d",t%10+'a',8-t/10);
  }
  t=(Move>>8) & 62; /* piece without color */
  if(t==0) { /* or if((t==0) && ((Move&3)<2)) { */
    if((Mask & 4)!=0) { printf("-"); } else { printf("?"); }
  } else {
    if((Mask & 4)!=0) { printf("x"); } else { printf("?"); }
    if((Mask & 2)!=0) {
      switch(t) {
        case WK: printf("K"); break;
        case ES:case WP: printf("P"); break; /* also en passant capture */
        case WN: printf("N"); break;
        case WB: printf("B"); break;
        case WR: printf("R"); break;
        case WQ: printf("Q"); break;
        default: printf("***error2***");
      }
    }
  }
  if((Mask & 1)!=0) {
    t=((Move>>2)&127) - 21; /* square */
    printf("%c%d",t%10+'a',8-t/10);
  }
  switch(Move&3) {
    case 0: printf("#"); break;
    case 1: printf("="); break;
    case 2: printf("*#"); break; /* special move: promotion, ep, castling */
    case 3: printf("*="); break;
  }
}


/**** Main *****************************************************************/
int main(argc,argv) int argc; char *argv[]; {
  int FileNb,FileLength,FilePos,Piece,Square,Occurence;
  FILE *FileP;
  char File[99999];
  unsigned char LF[1]={10};
  int c,i,x,y;

  
  //****** PROCESS ONE FILE ******
  for(FileNb=StartFile;FileNb<=EndFile;FileNb++) {
//    printf("%s\n",FileName);
    // load File
    FileP=fopen(FileName,"rb");
    if(FileP==0) { printf("error: %s not found\n",FileName); exit(1); }
    fseek(FileP,0,2); // 2 for EOF
    FileLength=(int) ftell(FileP);
    fseek(FileP,0,0); // 0 for SOF
    fread(File,1,FileLength,FileP);
    fclose(FileP);
    // change to next FileName
    FileName[3]++;
    if(FileName[3]=='9'+1) {
      FileName[3]='0';
      FileName[2]++;
      if(FileName[2]=='9'+1) {
        FileName[2]='0';
        FileName[1]++;
        if(FileName[1]=='9'+1) {
          FileName[1]='0';
          FileName[0]++;
        }
      }
    }
    // search "Ending moves;occurences", then skip this line up to LF
    FilePos=SearchNext((char *) "Ending",6,File,FileLength,0);
    FilePos=SearchNext((char *) LF,1,File,FileLength,FilePos)+1;
    // convert and insert every ending move
    while((File[FilePos]>='1') && (File[FilePos]<='9')) {
      // convert ending move
      IM_Ply=(File[FilePos]-'1');
      FilePos+=2;
      
//Specific to logical progressive chess
      if(File[FilePos-1]=='0') { FilePos++; IM_Ply=10; }
      IM_Move=IM_Ply<<26;             // ply (6 bits)
      switch(File[FilePos]) {
        case'K':Piece=WK;break;
        case'Q':Piece=WQ;break;
        case'R':Piece=WR;break;
        case'B':Piece=WB;break;
        case'N':Piece=WN;break;
        case'P':Piece=WP;break;
        default: printf("error: %c unknown piece\n",File[FilePos]); exit(1);
      }
      IM_Move+=(Piece&254)<<(21-1);   // piece (5 bits)
      FilePos+=1;
      Square=21+(File[FilePos]-'a')+10*('8'-File[FilePos+1]);
      IM_Move+=Square<<14;            // square in [0;119] (7 bits)
      FilePos+=2;
      if(File[FilePos]=='-') {
        Piece=ES;
      } else {
        FilePos+=1;
        switch(File[FilePos]) {
          case'K':Piece=WK;break;
          case'Q':Piece=WQ;break;
          case'R':Piece=WR;break;
          case'B':Piece=WB;break;
          case'N':Piece=WN;break;
          case'P':Piece=WP;break;
          default: printf("error: %c unknown piece\n",File[FilePos]); exit(1);
        }
      }
      IM_Move+=(Piece&254)<<(9-1);    // piece (5 bits)
      FilePos+=1;
      Square=21+(File[FilePos]-'a')+10*('8'-File[FilePos+1]);
      IM_Move+=Square<<2;             // square in [0;119] (7 bits)
      FilePos+=2;
      if(File[FilePos]=='*') { IM_Move+=2; } // special mate?
      FilePos=SearchNext((char *) ";",1,File,FileLength,FilePos)+1;
      // convert occurence
      Occurence=0;
      do {
        Occurence=Occurence*10+File[FilePos]-'0';
        FilePos++;
      } while((File[FilePos]>='0') && (File[FilePos]<='9'));
      IM_Found=FALSE;
      IM_t=0;
      while((IM_t<NbEndMoves) && (IM_Found==FALSE)) {
        if(IM_Move==EndMove[IM_t]) {
          IM_Found=TRUE;
          EndMoveOccurence[IM_t]+=Occurence;
        }
        IM_t++;
      }
      if(IM_Found==FALSE) {
        // print move
//        PrintMove(IM_Move,15); printf(";%d\n",Occurence);
        // insert move in list then increase NbEndMoves
        EndMove[NbEndMoves]=IM_Move;
        EndMoveOccurence[NbEndMoves]=Occurence;
        EndMoveFileNb[NbEndMoves]=FileNb;
        NbEndMoves++;
        if(NbEndMoves>=MaxNbEndMoves) {
          printf("***error: More than %d EndMove!\n",MaxNbEndMoves); exit(-1);
        }
      }
      FilePos=SearchNext((char *) LF,1,File,FileLength,FilePos)+1;
    } // next ending move
  } //****** NEXT FILE ******
  
//  printf("%d endmoves\n",NbEndMoves);
        
  /* sort (stupidly) the EndMove according to their occurence */
  if(NbEndMoves!=0) {
    for(x=0;x<NbEndMoves-1;x++) {
      i=x;
      c=EndMoveOccurence[x];
      for(y=x+1;y<NbEndMoves;y++) {
        if(EndMoveOccurence[y]<c) { c=EndMoveOccurence[y]; i=y; }
      }
      c=EndMove[x];
      EndMove[x]=EndMove[i];
      EndMove[i]=c;
      c=EndMoveOccurence[x];
      EndMoveOccurence[x]=EndMoveOccurence[i];
      EndMoveOccurence[i]=c;
      c=EndMoveFileNb[x];
      EndMoveFileNb[x]=EndMoveFileNb[i];
      EndMoveFileNb[i]=c;
    }
  }

  // Print the ending moves
  printf("\nEnding moves;occurences\n");
  for(i=0;i<NbPlies+1;i++) {
    for(c=0;c<NbEndMoves;c++) {
      x=EndMove[c];
      y=(x>>26);
      if(y==i) {
        PrintMove(x,15);printf(";%d\n",EndMoveOccurence[c]);
      }
    }
  }

  /* search for minimal information for every unique EndMove */
  printf("\npossible problems;file nb\n");
  unsigned int NbMinimal[8]; /* 8 types of minimal information, see below */
  c=0;
  while((EndMoveOccurence[c]==1) && (c<NbEndMoves)) {
    x=EndMove[c];
    for(i=0;i<8;i++) { NbMinimal[i]=0; }
    for(i=0;i<NbEndMoves;i++) {
      y=EndMove[i];
      /* Same ply, same playing piece, same type of endmove? */
      if( (x&((2047<<21)+3))==(y&((2047<<21)+3)) ) {
        NbMinimal[0]++; /* n.piece# */
        /* Same destination square? */
        if( (x&(127<<2))==(y&(127<<2)) ) {
          NbMinimal[4]++; /* n.piece?square# */
        }
        /* Both are moves without capture? */
        if( ((x&(31<<9))==0) && ((y&(31<<9))==0) ) {
          NbMinimal[1]++; /* n.piece-# */
          /* Same destination square? */
          if( (x&(127<<2))==(y&(127<<2)) ) {
            NbMinimal[5]++; /* n.piece-square# */
          }
        } else {
          /* Both are captures? */
          if( ((x&(31<<9))!=0) && ((y&(31<<9))!=0) ) {
            NbMinimal[2]++; /* n.piecex# */
            /* Same piece captured? */
            if( (x&(31<<9))==(y&(31<<9)) ) {
              NbMinimal[3]++; /* n.piecexpiece# */
              /* Also same destination square?*/
              if( (x&(127<<2))==(y&(127<<2)) ) {
                NbMinimal[7]++; /* n.piecexpiece_square# */
              }
            }
            /* Same destination square?*/
            if( (x&(127<<2))==(y&(127<<2)) ) {
              NbMinimal[6]++; /* n.piecexsquare# */
            }
          }
        }
      }
    }
    /* Print minimal info for this move */
    i=0;
    while((NbMinimal[i]!=1) && (i<8)) { i++; }
    switch(i) {
      case 0:printf("*"); PrintMove(x,0); break; /* n.piece# */
      case 1:                       /* n.piece-# */
      case 2:printf("*"); PrintMove(x,4); break; /* n.piecex# */
      case 3:printf("*"); PrintMove(x,6); break; /* n.piecexpiece# */
      case 4:printf("*"); PrintMove(x,1); break; /* n.piece?square# */
      case 5:                       /* n.piece-square# */
      case 6:printf("*"); PrintMove(x,5); break; /* n.piecexsquare# */
      case 7:printf("*"); PrintMove(x,7); break; /* n.piecexpiece_square# */
      default: PrintMove(x,15); break;
    }
    printf(";%d\n",EndMoveFileNb[c]);
    c++;
  }
  exit(0);
}
